org.cpsolver.studentsct.heuristics.studentord

## Class StudentChoiceRealFirstOrder

- java.lang.Object
- - org.cpsolver.studentsct.heuristics.studentord.StudentChoiceOrder
  - - org.cpsolver.studentsct.heuristics.studentord.StudentChoiceRealFirstOrder

- All Implemented Interfaces:
    Comparator<Student>, StudentOrder

      public class StudentChoiceRealFirstOrder
      extends StudentChoiceOrder

  Return the given set of students in an order of average number of choices of each student (students with more choices first), however, real student are before last-like students. By default, the order is reversed (students with less choices first).
  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `StudentChoiceRealFirstOrder()`
    `StudentChoiceRealFirstOrder(DataProperties config)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `compare(Student s1, Student s2)`

    - ### Methods inherited from class org.cpsolver.studentsct.heuristics.studentord.StudentChoiceOrder

      `avgNrChoices, getRequestPriority, isCriticalOnly, isReverse, order, setCriticalOnly, setRequestPriority, setReverse`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface java.util.Comparator

      `comparing, comparing, comparingDouble, comparingInt, comparingLong, equals, naturalOrder, nullsFirst, nullsLast, reversed, reverseOrder, thenComparing, thenComparing, thenComparing, thenComparingDouble, thenComparingInt, thenComparingLong`

- - ### Constructor Detail

    - #### StudentChoiceRealFirstOrder

          public StudentChoiceRealFirstOrder(DataProperties config)

    - #### StudentChoiceRealFirstOrder

          public StudentChoiceRealFirstOrder()

  - ### Method Detail

    - #### compare

          public int compare(Student s1,
                             Student s2)

      Specified by:
        `compare` in interface `Comparator<Student>`
      Overrides:
        `compare` in class `StudentChoiceOrder`